% close all;   
clear all;
    global a r gamma s  f beta d z delta theta Kmax R c1 c2 D v Hg He m keep1 keep2;
    Hg=0.03;
    He=0.01;
    Kmax=17.745;
    R=1.6;
    P=0.1  ;
    c1=3.65;
    c2=-3.21;
    D=4.557;
    v=0.9877;
    % artificial complexity
    delta=0;
    deltap=0.1;
    beta=1;
    r=1;
    d=0.44;
    s=0.49;
    a=0.1;
    gamma=0.8;
    z=0.5;
    theta=0;
    
%     for one population (V2), f is the migration parameter, 
%     for two populations, the migratioan is m, and the amount left for 
%     the populations is keep
    f=0;
    m=0.12; 
%estimated values of migration 
% 0.036,0.12,0.47,0.812,2.66
    keep1=1;
    keep2=0;
    time=20;
% time=5;
% determine points
times=time+1;
% times=11;


 points=200;
% points=10;
CVec=linspace(0,1,points);
MVec=linspace(0,1,points);
%  Phase plane
phase=-1*ones(points,points,times,2);
% finalC=-1*ones(points,points);

for k=1:2
    if(k==1)
        deltaP=0;
%         deltaP=0.1;
%         delta=0;
%         f=0;

    end
    
    if(k==2)
        deltaP=0.1;
%         delta=0.1;

%         f=0.1;

    end
    
    
for i =1:points
    (i+(k-1)*points)/(points*2)
C=CVec(i);
j=1;
while((j<points+1)&&(MVec(j)+CVec(i)<=1) )
   
M=MVec(j);
T=1-M-C;
% T=1-M-C+delta;
% P=0.001+deltaP;
P=0.1+deltaP;
% initialcondvecV2=[M,C,T,P,R+delta];
initialcondvecV3=[M,C,T,P+deltaP,R,M,C,T,P,R];

 [t,Y] = ode45('CoralOdeV3',linspace(0,time,times), initialcondvecV3);
phase(i,j,:,k)=Y(:,2)+Y(:,7);

  j=j+1;
end
end
end

% reef size
X=15;
fishdensity=3000;
% fishcost=100;
% fishcost=50;
fishcost=20;



% benefitC=2.35*10^7;
benefitC=2*10^5;

discount=0.05;
% discount=0.07;

benefit1=-1*ones(points,points,time+1,2);
for i=1:(time+1)
% benefit(:,:,i,:)=phase(:,:,i,:)/(1+discount)^(i-1);
% benefit1(:,:,i,:)=phase(:,:,i,:)*X*benefitC*(1+discount)^(time-i+1);
benefit1(:,:,i,:)=phase(:,:,i,:)*X*benefitC*(1+discount)^(-i+1);

end
benefit=reshape(sum(benefit1,3),points,points,2);
% benefit=sum(phase,3)*X*benefitC;
% cost=0;
 benefit(benefit<0)=NaN;

cost=zeros(points,points,2);
% cost(1:points,1:points,2)=fishdensity*fishcost*X*deltaP*(1+discount)^time;
cost(1:points,1:points,2)=fishdensity*fishcost*X*deltaP;

% RugCost=90000;
% cost(1:100,1:100,2)=(fishdensity*fishcost*X*deltaP+RugCost*X)*(1+discount)^time;

revenue=benefit-cost;


% BCR=benefit/cost;
% BCR(BCR<=0)=NaN;
% function for years
    

% figure(1)
% [U,V]=meshgrid((1:points),(1:points));
% surf(U,V,log(BCR))
% % shading flat 
%  xlabel('M')
%  ylabel('C')
%  set(gca, 'CLim', [min(min(log(BCR))), max(max(log(BCR)))]);
%  view([0 90])
% %   contour(Phase)
%  print -dmeta

%

figure(1)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,reshape(phase(:,:,times,1),points,points))
title('No stock enhancement')
% shading flat 
 xlabel('M')
 ylabel('C')
view([0 90])

figure(2)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,reshape(phase(:,:,times,2),points,points))
title('Stock enhancement')
% shading flat 
 xlabel('M')
 ylabel('C')
view([0 90])



%  save('revenueNoStockP05Y20','revenue');

% 
% load('revenueNoStockP05Y20');
%   load('revenueStockP05Y20');

%  revenue(revenue<0)=NaN;
 revenueStock=revenue(:,:,2);
  revenueNoStock=revenue(:,:,1);

 figure(3)
 subplot(1,2,2)
[U,V]=meshgrid((1:points),(1:points));
% surf(U,V,revenueStock-revenueNoStock)
new=revenueStock-revenueNoStock;
new(new<0)=0;
surf(U,V,log10(new+1))
colormap('jet')
grid off
xlim([1 points])
ylim([1 points])
% fixes the colorbar bug!!
set(gcf, 'renderer', 'zbuffer')
shading flat 
 xlabel('M','FontSize', 18)
 ylabel('C','FontSize', 18)
  set(gca, 'CLim', [min(min(revenueStock-revenueNoStock)), max(max(revenueStock-revenueNoStock))]);
 view([0 90])
 title(strcat(num2str(time),'-year revenue'),'FontSize', 18)
 colorbar
 set(gca, 'CLim', [min(min(new)),7]);

 set(gca,'FontSize',22)
%   contour(Phase)

load('NotNTwo200');load('Res1Two200');load('Res2Two200')
load('NotH1Two200');load('NotH2Two200')

NotNTwo(NotNTwo==(length(NotNTwo)+1))=NaN;
Res1Two(Res1Two==(length(Res1Two)+1))=NaN;
Res2Two(Res2Two==(length(Res2Two)+1))=NaN;
NotH1Two(NotH1Two==(length(NotH1Two)+1))=NaN;
NotH2Two(NotH2Two==(length(NotH2Two)+1))=NaN;


Yl=1:points;
% Zl=(4)*ones(1,points);
Zl=(max(max(revenueStock-revenueNoStock))+1)*ones(1,points);
l=line(NotNTwo,Yl,Zl,'Color','black','LineWidth',1.5);
l2=line(Res1Two,Yl,Zl,'Color','black','LineWidth',2);
l3=line(Res2Two,Yl,Zl,'Color','black','LineWidth',1.5);
l4=line(NotH1Two,Yl,Zl,'Color','black','LineWidth',1.5);
l5=line(NotH2Two,Yl,Zl,'Color','black','LineWidth',1.5);


 print -dmeta

 
 
 
% % %  time series plotting
time=100;
times=time+1;
f=0;
%  C=0.35;
%  M=0.07;
 C=0.35;
 M=0.05;
T=1-M-C;
deltaP=0.1;
P=0;
initialcondvecV3=[M,C,T,P+deltaP,R,M,C,T,P,R];
 [t,Y] = ode45('CoralOdeV3',linspace(0,time,times), initialcondvecV3);
  figure(4)
 subplot(1,2,1)
plot(t,Y(:,[1 2 4 ]),'LineWidth',4);
hold on
plot(t,Y(:,[6 7 9]),'LineWidth',4,'LineStyle','- -');
legend('M_{I}','C_{I}','P_{I}','M_{II}','C_{II}','P_{II}')
xlim([0 time])
ylim([0 1])
    set(gca,'FontSize',17)
ylabel('Variables','FontSize',16);
xlabel('Time(years)','FontSize',16);
title('Restocking','FontSize',20);
% title('$WT$','Interpreter','LaTex','FontSize',20);
 print -dmeta
 
 
 