% look at revenues for given time-cost of adding fish
% other option-find the equilibrium, cutoff at 0.9*equilibrium
% close all;
clear all;
global a r gamma s  f beta d z delta theta Kmax R c1 c2 D v Hg He;
Hg=0.03;
He=0.01;
Kmax=17.745;
R=1.6;
c1=3.65;
c2=-3.21;
D=4.557;
v=0.9877;
f=0.12;   %can be thought of as migration (m) as well
%estimated values of migration
% 0.036,0.12,0.47,0.812,2.66
beta=1;
r=1;
d=0.44;
s=0.49;
a=0.1;
gamma=0.8;
z=0.5;
theta=0;
%added stock
% deltaP=0.1;
deltaP=0;
% artificial complexity

delta=0;
% time=5;
time=20;
% determine points
times=time+1;
% times=11;


 points=200;
% points=20;
CVec=linspace(0,1,points);
MVec=linspace(0,1,points);
%  Phase plane
phase=-1*ones(points,points,times,2);
% finalC=-1*ones(points,points);

for k=1:2
    if(k==1)
        deltaP=0;
        %         deltaP=0.1;
        %         delta=0;
        %         f=0;
        
    end
    
    if(k==2)
        deltaP=0.1;
        %         delta=0.1;
        
        %         f=0.1;
        
    end
    for i =1:points
        if(mod(i,10)==0)
            (i+(k-1)*points)/(points*2)
        end
        C=CVec(i);
        j=1;
        while((j<points+1)&&(MVec(j)+CVec(i)<=1) )
            
            M=MVec(j);
            T=1-M-C;
            % T=1-M-C+delta;
            % P=0.001+deltaP;
            P=0.1+deltaP;
            % initialcondvecV2=[M,C,T,P,R+delta];
            initialcondvecV2=[M,C,T,P,R];
            
            [t,Y] = ode45('CoralOdeV2',linspace(0,time,times), initialcondvecV2);
            phase(i,j,:,k)=Y(:,2);
            % finalC(i,j)=Y(length(Y(:,2)),2);
            
            j=j+1;
        end
    end
end

% reef size
X=15;
fishdensity=3000;
% fishcost=100;
% fishcost=50;
fishcost=20;


% benefitC=2.35*10^7;
benefitC=2*10^5;

discount=0.05;
% discount=0.07;

benefit1=-1*ones(points,points,time+1,2);
for i=1:(time+1)
    % benefit(:,:,i,:)=phase(:,:,i,:)/(1+discount)^(i-1);
    % benefit1(:,:,i,:)=phase(:,:,i,:)*X*benefitC*(1+discount)^(time-i+1);
    benefit1(:,:,i,:)=phase(:,:,i,:)*X*benefitC*(1+discount)^(-i+1);
    
end
benefit=reshape(sum(benefit1,3),points,points,2);
% benefit=sum(phase,3)*X*benefitC;
% cost=0;
benefit(benefit<0)=NaN;

cost=zeros(points,points,2);
% cost(1:points,1:points,2)=fishdensity*fishcost*X*deltaP*(1+discount)^time;
cost(1:points,1:points,2)=fishdensity*fishcost*X*deltaP;

% RugCost=90000;
% cost(1:100,1:100,2)=(fishdensity*fishcost*X*deltaP+RugCost*X)*(1+discount)^time;

revenue=benefit-cost;


% BCR=benefit/cost;
% BCR(BCR<=0)=NaN;
% function for years


% figure(1)
% [U,V]=meshgrid((1:points),(1:points));
% surf(U,V,log(BCR))
% % shading flat
%  xlabel('M')
%  ylabel('C')
%  set(gca, 'CLim', [min(min(log(BCR))), max(max(log(BCR)))]);
%  view([0 90])
% %   contour(Phase)
%  print -dmeta

%

figure(1)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,reshape(phase(:,:,times,1),points,points))
title('No stock enhancement')
% shading flat
xlabel('M')
ylabel('C')
view([0 90])

figure(2)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,reshape(phase(:,:,times,2),points,points))
title('Stock enhancement')
% shading flat
xlabel('M')
ylabel('C')
view([0 90])



%  save('revenueNoStockP05Y20','revenue');

%
% load('revenueNoStockP05Y20');
%   load('revenueStockP05Y20');

%  revenue(revenue<0)=NaN;
revenueStock=revenue(:,:,2);
revenueNoStock=revenue(:,:,1);

figure(3)
subplot(1,2,2)
[U,V]=meshgrid((1:points),(1:points));
% surf(U,V,revenueStock-revenueNoStock)
new=revenueStock-revenueNoStock;
new(new<0)=0;
surf(U,V,log10(new+1))
grid off
colormap('jet')
xlim([1 points])
ylim([1 points])

% fixes the colorbar bug!!
set(gcf, 'renderer', 'zbuffer')
shading flat
xlabel('M','FontSize', 18)
ylabel('C','FontSize', 18)
%   set(gca, 'CLim', [min(min(revenueStock-revenueNoStock)), max(max(revenueStock-revenueNoStock))]);
%   set(gca, 'CLim', [min(min(new)), max(max(new))]);
set(gca, 'CLim', [min(min(new)),7]);


view([0 90])
title(strcat(num2str(time),'-year revenue'),'FontSize', 18)
colorbar
set(gca,'FontSize',18)
%   contour(Phase)




% load('NotH');load('NotN');load('Res')
load('NotH200');load('NotN200');load('Res200')

NotH(NotH==(length(NotH)+1))=NaN;
NotN(NotN==(length(NotN)+1))=NaN;
Res(Res==(length(Res)+1))=NaN;

Yl=1:points;
% Zl=(4)*ones(1,points);
Zl=log10(max(max(revenueStock-revenueNoStock))+1)*ones(1,points);
l=line(NotH,Yl,Zl,'Color','black','LineWidth',1.5);
% l2=line(NotN,Yl,Zl,'Color','black','LineWidth',2);
l3=line(Res,Yl,Zl,'Color','black','LineWidth',1.5);



print -dmeta


% % % %  time series plotting
time=100;
times=time+1;
f=0.12;
%  C=0.35;
%  M=0.05;
 C=0.35;
 M=0.07;
T=1-M-C;
deltaP=0;
P=0.1+deltaP;
initialcondvecV2=[M,C,T,P,R];
 [t,Y] = ode45('CoralOdeV2',linspace(0,time,times), initialcondvecV2);
  figure(4)
 subplot(1,2,2)
plot(t,Y(:,[1 2 4]),'LineWidth',4);
legend('M','C','P')
xlim([0 time])
ylim([0 1])
    set(gca,'FontSize',17)
ylabel('Variables','FontSize',16);
xlabel('Time(years)','FontSize',16);
title('No intervention','FontSize',20);
% title('$WT$','Interpreter','LaTex','FontSize',20);
%  print -dmeta


