close all;   
clear all;
    global a r gamma s  f beta d z delta theta Kmax R c1 c2 D v Hg He m keep1 keep2;
    Hg=0.03;
    He=0.01;
    Kmax=17.745;
    R=1.6;
    P=0.1  ;
    c1=3.65;
    c2=-3.21;
    D=4.557;
    v=0.9877;
    % artificial complexity
    delta=0;
    deltap=0.1;
    beta=1;
    r=1;
    d=0.44;
    s=0.49;
    a=0.1;
    gamma=0.8;
    z=0.5;
    theta=0;
    
%     for one population (V2), f is the migration parameter, 
%     for two populations, the migratioan is m, and the amount left for 
%     the populations is keep
    f=0;
    m=0.12; 
%estimated values of migration 
% 0.036,0.12,0.47,0.812,2.66
    keep1=1;
    keep2=0;
time=300;


points=200;
% points=20;

CVec=linspace(0,1,points);
MVec=linspace(0,1,points);
PVec=linspace(0,1,points);

%  Phase plane
phase=zeros(points,points,2)-1;

for l=1:2
if(l==1)
    
    deltaP=0; 
end

if(l==2)
    deltaP=0.1; 
end


for i =1:points
    (i+(l-1)*points)/(points*2)
C=CVec(i);
j=1;
while((j<points+1)&&(MVec(j)+CVec(i)<=1) )
   
M=MVec(j);
T=1-M-C;

initialcondvecV3=[M,C,T,P+deltaP,R,M,C,T,P,R];

 [t,Y] = ode45('CoralOdeV3',linspace(0,time,time+1), initialcondvecV3);

if(Y(length(Y(:,2)),2)>0.5 && Y(length(Y(:,2)),7)>0.5)
phase(i,j,l)=10;
elseif(Y(length(Y(:,2)),2)<0.5&& Y(length(Y(:,2)),7)>0.5)

phase(i,j,l)=100;
elseif(Y(length(Y(:,2)),2)>0.5&& Y(length(Y(:,2)),7)<0.5)

phase(i,j,l)=1000;
else
  
phase(i,j,l)=0;
end
% phase(i,j)=Y( length(Y(:,2)),2);
  j=j+1;
  
  
%   if( l==2)   %%%looking at trajectories
%    figure(3)
%    subplot(2,1,1)
%  plot(Y(:,1),Y(:,2))
%  xlim([0 1])
%  ylim([0 1])
%  hold on
%   subplot(2,1,2)
%  plot(Y(:,6),Y(:,7))
%  xlim([0 1])
%  ylim([0 1])
%  hold on
%   end
%   
  
end
end
end

  
 Phase=zeros(points,points);

   

%     Adding fish helps both
   Phase(phase(:,:,1)+phase(:,:,2)==10)=1;

%    intervention saves only one
 Phase(phase(:,:,1)+phase(:,:,2)==100)=2;
 

  Phase(phase(:,:,1)+phase(:,:,2)==1000)=2;
  %    intervention saves the other reef
  Phase(phase(:,:,1)+phase(:,:,2)==110)=4;
  
  Phase(phase(:,:,1)+phase(:,:,2)==1010)=4;
    %     No intervention needed in any of reefs
    
    
   Phase(phase(:,:,1)==10)=3;
      Phase((phase(:,:,1)==phase(:,:,2))&((phase(:,:,1)==100)|(phase(:,:,1)==1000)))=5;
%     out of bounds
    Phase(phase(:,:,1)==-1)=NaN;% put these clauses last!
    % Nothing helps
    Phase(phase(:,:,1)+phase(:,:,2)==0)=0;


figure(1)
% subplot(2,2,2)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,Phase)
set(gcf, 'renderer', 'zbuffer')

% shading flat 
 xlabel('M')
 ylabel('C')
 view([0 90])
  colorbar
%   contour(Phase)
 print -dmeta

 figure(2)
 plot(t,Y)
 legend('M','C','T','P','R','M2','C2','T2','P2','R2')

 
 NotNTwo=zeros(1,points);
Res1Two=zeros(1,points);
Res2Two=zeros(1,points);
NotH1Two=zeros(1,points);
NotH2Two=zeros(1,points);

for i=1:points
    NotNTwo(i)=find([Phase(i,:), 3]==3,1);
    Res1Two(i)=find([Phase(i,:), 2]==2,1);
    Res2Two(i)=find([Phase(i,:), 4]==4,1);
    NotH1Two(i)=find([Phase(i,:), 0]==0,1);
    NotH2Two(i)=find([Phase(i,:), 5]==5,1);

end

 
 