clear all;
global a r gamma s  f beta d z delta theta Kmax R c1 c2 D v Hg He;
Hg=0.03;
He=0.01;
Kmax=17.745;
R=1.6;
c1=3.65;
c2=-3.21;
D=4.557;
v=0.9877;
% artificial complexity
delta=0;
f=0.12;   %can be thought of as migration (m) as well
%estimated values of migration
% 0.036,0.12,0.47,0.812,2.66
% f=0.375;
beta=1;
r=1;
d=0.44;
s=0.49;
a=0.1;
gamma=0.8;
z=0.5;
theta=0;
delta=0;

time=150;


points=20;
% points=50;

CVec=linspace(0,1,points);
MVec=linspace(0,1,points);
PVec=linspace(0,1,points);

%  Phase plane
phase=zeros(points,points,3)-1;

for m=1:2
    if(m==1)
        
        deltaP=0;
    end
    
    if(m==2)
        deltaP=0.1;
    end
    
    
    for i =1:points
        i
        C=CVec(i);
        j=1;
        while((j<points+1)&&(MVec(j)+CVec(i)<=1) )
            
            M=MVec(j);
            T=1-M-C;
            % T=1-M-C+delta;
            
            P=0.1+deltaP;
            
            % P=0.05+deltaP;
            % initialcondvec=[M,C,T,P];
            initialcondvecV2=[M,C,T,P,R];
            
            [t,Y] = ode45('CoralOdeV2',[0,time], initialcondvecV2);
            
            hold on
            if(Y(length(Y(:,2)),2)>Y(length(Y(:,2)),1))
                phase(i,j,m)=10*m;
            else
                phase(i,j,m)=0;
            end
            % phase(i,j)=Y( length(Y(:,2)),2);
            j=j+1;
        end
    end
end
% ylim([0 1+delta])
% xlim([0 1+delta])

%   xlabel('P')
xlabel('M')
ylabel('C')

Phase=zeros(points,points);
%     out of bounds
Phase(phase(:,:,1)==-1)=NaN;
% Nothing helps
Phase(phase(:,:,1)+phase(:,:,2)==0)=0;

%     Adding fish helps
Phase((phase(:,:,2)==20))=2;

%     No intervention needed
Phase(phase(:,:,1)==10)=1;
% count=0
% Mat=zeros(points^2,3);
% for i =1:points
%     for j =1:points
%         count=count+1;
%         Mat(count,1)=i;
%         Mat(count,2)=j;
%         Mat(count,3)=Phase(i,j);
%     end
% end

figure(1)
% subplot(2,2,2)
[U,V]=meshgrid((1:points),(1:points));
surf(U,V,Phase)
view([0 90])
% shading flat
xlabel('M')
ylabel('C')
%   contour(Phase)
print -dmeta

%%%%finding the line that separetes the areas
NotN=zeros(1,points);
Res=zeros(1,points);
NotH=zeros(1,points);
for i=1:points
    NotN(i)=find([Phase(i,:), 1]==1,1);
    Res(i)=find([Phase(i,:), 2]==2,1);
    NotH(i)=find([Phase(i,:), 0]==0,1);
end

